#include "DistrhoPlugin.hpp"

START_NAMESPACE_DISTRHO

class Limiter : public Plugin
{
public:
	Limiter()
		: Plugin(2, 0, 0)
	{
	}

protected:
	const char *getLabel() const override { return "yaw-brick"; }
	const char *getDescription() const override { return "Limiter"; }
	const char *getMaker() const override { return "yaw-audio"; }
	const char *getHomePage() const override { return "https://yaw.man/plugins/yaw-brick"; }
	const char *getLicense() const override { return "Fuck you pay me"; }
	uint32_t getVersion() const override { return d_version(1, 0, 0); }
	int64_t getUniqueId() const override { return d_cconst('y', 'b', 'r', 'k'); }

	void initParameter(uint32_t index, Parameter &parameter) override
	{
		parameter.hints = kParameterIsAutomable;
		parameter.ranges.def = 0.0f;
		parameter.ranges.min = 0.0f;
		parameter.ranges.max = 1.0f;
		parameter.name = "param";
		parameter.symbol = "param";
	}

	void sampleRateChanged(double newRate) override
	{}

	float getParameterValue(uint32_t index) const override
	{
		return index ? gain : limit;
	}

	void setParameterValue(uint32_t idx, float val) override
	{
		if( idx ) { limit = val; }
		else { gain = val; }
	}

	void run(const float **inputs, float **outputs, uint32_t frames) override
	{
		for (int chn = 0; chn < 2; ++chn)
		{
			for( uint32_t i = 0; i < frames; ++i){
				float x = inputs[chn][i];
				outputs[chn][i] = gain * limit * x / (1.f + gain * x);
			}
		}
	}

private:
    double limit = 0.0;
	double gain = 0.0;
	DISTRHO_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR(Limiter)
};

Plugin *createPlugin()
{
	return new Limiter();
}

END_NAMESPACE_DISTRHO
